// my vdpol #2
// chaotic trajectory with sliders
// code frags: xforms, vdpol, coloring

//GLOBALS ======================================

var slidera;
var sliderb;
var msg;
var a; // to hold slider value
var b; // to hold slider value
var runtime = 0.0; // time along trajectory
var dt = 0.001; // euler timestep
var finaltime = 10.0; // when to stop plot
var dwell = 1.5; // time to decay tanssient
var canvas1;

// MATH COORDS (u, v)
//init conditions
var u0 = 1.0; 
var v0 = 1.0;
// the vdpol domain (square)
var umin = -2.0;
var umax = 2.0;
var vmin = -2.0;
var vmax = 2.0;
var udelta = umax - umin;
var vdelta = vmax - vmin;
// math coords for trajectory with init values
var unow = u0;
var vnow = v0;
var unext = unew(unow, vnow);
var vnext = vnew(unow, vnow);

// CANVAS COORDS (x, y)
// canvas size, (0, 0) to (500, 500)
var h = 500;
var w = 500;
// canvas coords for trajectry
var xnow = xcanvas(unow);
var ynow = ycanvas(vnow);
var xnext = xcanvas(unext);
var ynext = ycanvas(vnext);

// drawing routines
function plot() {
	// reset inits
	unow = u0; 
	vnow = v0;
	runtime = 0.0;
	//plot init point
	// convert
	xnow = xcanvas(unow, width);
	ynow = ycanvas(vnow, height);
	fill(0); // black, for initial point
	ellipse(xnow, ynow, 10, 10); // small circular dot
	// now iterate
	while (runtime < finaltime) {
		// update runtime
		runtime += dt;
		// iterate
		unext = unew(unow, vnow);
		vnext = vnew(unow, vnow);
		// set colors
		if ( runtime < dwell ) { 
			stroke(0, 0, 255); // blue
		}
		else {
			stroke(255, 0, 0); // blue
		}
		// convert
		xnow = xcanvas(unow, width);
		ynow = ycanvas(vnow, height);
		//
		xnext = xcanvas(unext, width);
		ynext = ycanvas(vnext, height);
		// display
		// ellipse(xnext, ynext, 2, 2);  // small red dot (could be rect 1 by 1)
		line(xnow, ynow, xnext, ynext);
		//swappo
		unow = unext;
		vnow = vnext;
		// clipping
		if (unow < -1.8) { unow = -1.7 };
		if (unow > 1.8) { unow = 1.7 };
		if (vnow < -1.8) { vnow = -1.7 };
		if (vnow > 1.8) { vnow = 1.7 };
	}
}

// begin usual sketch code ======================
function setup() {
	// set canvas
	canvas1 = createCanvas(w, h);
	background(200); // 20% gray
	// plot trajectory
	noStroke();
	// for text
	textFont("Arial");
	textSize(24);
	//slidera
	//args = (min, max, default value, step size) last = 0 for continuous motion
	// a range 
	slidera = createSlider(-2.0, 2.0, 0.7, 0.1); // floating point slider
	slidera.position(20, h + 140); // args = upper left corner (x, y)
	slidera.style('width', '500px');
	//sliderb
	sliderb = createSlider(-2.0, 2.0, 1.0, 0.1); // floating point slider
	sliderb.position(20, h + 180); // args = upper left corner (x, y)
	sliderb.style('width', '500px');
	//sliderd dwell
	sliderd = createSlider(0.0, 20.0, 5.0, 1.0); // floating point slider
	sliderd.position(20, h + 220); // args = upper left corner (x, y)
	sliderd.style('width', '500px');

} // end setup

function draw() {
	background(200); // clear the canvas to gray
	a = slidera.value(); // update coeffs
	b = sliderb.value();
	dwell = sliderd.value();
	plot(); // draw trajectory
	fill(0); // black for text
	msg = "a = " + a + ", b = " + b + ", dwell = " + dwell;
	text(msg, 24, 30, 400, 100); // publish coeff values
}


// end of sketch
